using Exferia_Aplicacion.General;
using Exferia_KairosPRO_EF;
using System;
using System.Collections.Generic;
using System.Data.SqlClient;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Exferia_KairosPRO._2_Datos
{
    public class TMP_Emails_RecordatorioFichajes_Datos
    {
        public List<TMP_Emails_RecordatorioFichajes> Obtener_Listado(long _lng_CodigoCliente)
        {
            KairosProEntities obj_KairosProEntities = null;
            List<TMP_Emails_RecordatorioFichajes> lst_TMP_Emails_RecordatorioFichajes = null;

            try
            {
                obj_KairosProEntities = new KairosProEntities();
                obj_KairosProEntities.Configuration.LazyLoadingEnabled = false;

                string str_SQL =
                " SELECT distinct " +
                        nameof(TMP_Emails_RecordatorioFichajes) + "." + nameof(TMP_Emails_RecordatorioFichajes.id) + "," +
                        nameof(TMP_Emails_RecordatorioFichajes) + "." + nameof(TMP_Emails_RecordatorioFichajes.codigoCliente) + "," +
                        nameof(TMP_Emails_RecordatorioFichajes) + "." + nameof(TMP_Emails_RecordatorioFichajes.idEmpleado) + "," +
                        nameof(TMP_Emails_RecordatorioFichajes) + "." + nameof(TMP_Emails_RecordatorioFichajes.fecha) + "," +
                        nameof(TMP_Emails_RecordatorioFichajes) + "." + nameof(TMP_Emails_RecordatorioFichajes.entradaSalida) + 
                       
                " FROM " + nameof(TMP_Emails_RecordatorioFichajes) +
                " WHERE " +
                            nameof(TMP_Emails_RecordatorioFichajes) + "." + nameof(TMP_Emails_RecordatorioFichajes.codigoCliente) + "=@codigoCliente " +
                " ORDER BY " +
                    nameof(TMP_Emails_RecordatorioFichajes.id) + " ASC ";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@codigoCliente",  _lng_CodigoCliente)
                };

                //Rellenar el Modelo
                lst_TMP_Emails_RecordatorioFichajes = obj_KairosProEntities.Database.SqlQuery<TMP_Emails_RecordatorioFichajes>(str_SQL, arr_Parametros).ToList();
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(TMP_Emails_RecordatorioFichajes_Datos) + "/" + nameof(Obtener_Listado), true);
            }
            finally
            {
                obj_KairosProEntities.Database.Connection.Close();
                obj_KairosProEntities.Dispose();
            }

            return lst_TMP_Emails_RecordatorioFichajes;
        }

        public void Insertar(TMP_Emails_RecordatorioFichajes _mdl_TMP_Emails_RecordatorioFichajes)
        {
            KairosProEntities obj_KairosProEntities = null;

            try
            {
                obj_KairosProEntities = new KairosProEntities();
                obj_KairosProEntities.Configuration.LazyLoadingEnabled = false;

                string str_SQL_Insert = " INSERT INTO " + nameof(TMP_Emails_RecordatorioFichajes) +
                                               " (" +
                                                        nameof(TMP_Emails_RecordatorioFichajes.codigoCliente) + "," +
                                                        nameof(TMP_Emails_RecordatorioFichajes.idEmpleado) + "," +
                                                        nameof(TMP_Emails_RecordatorioFichajes.fecha) + "," +
                                                        nameof(TMP_Emails_RecordatorioFichajes.entradaSalida) + 
                                               " ) " +
                                               " OUTPUT INSERTED." + nameof(TMP_Emails_RecordatorioFichajes.id) +
                                               " VALUES " +
                                               " ( " +
                                                    "@codigoCliente," +
                                                    "@idEmpleado," +
                                                    "@fecha," +
                                                    "@entradaSalida" +
                                               " ) ";
                //Parametros
                object[] arr_Parametros_Insert = new object[]
                {
                    new SqlParameter("@codigoCliente",  _mdl_TMP_Emails_RecordatorioFichajes.codigoCliente),
                    new SqlParameter("@idEmpleado",  _mdl_TMP_Emails_RecordatorioFichajes.idEmpleado),
                    new SqlParameter("@fecha",  _mdl_TMP_Emails_RecordatorioFichajes.fecha),
                    new SqlParameter("@entradaSalida",  _mdl_TMP_Emails_RecordatorioFichajes.entradaSalida)
                };

                //Id de la tabla
                obj_KairosProEntities.Database.SqlQuery<long>(str_SQL_Insert, arr_Parametros_Insert).Single();

            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(TMP_Emails_RecordatorioFichajes_Datos) + "/" + nameof(Insertar), true);
            }
            finally
            {
                obj_KairosProEntities.Database.Connection.Close();
                obj_KairosProEntities.Dispose();
            }
        }

        public void Borrar(long _lng_id, long _lng_CodigoCliente)
        {
            KairosProEntities obj_KairosProEntities = null;

            try
            {

                obj_KairosProEntities = new KairosProEntities();
                obj_KairosProEntities.Configuration.LazyLoadingEnabled = false;

                #region Delete
                string str_SQL_Delete = " DELETE FROM  " + nameof(TMP_Emails_RecordatorioFichajes) +
                                        " WHERE " +
                                            nameof(TMP_Emails_RecordatorioFichajes.id) + "=@id and " +
                                            nameof(TMP_Emails_RecordatorioFichajes.codigoCliente) + "=@codigoCliente ";
                //Parametros
                object[] arr_Parametros_Delete = new object[]
                {
                    new SqlParameter("@id", _lng_id),
                    new SqlParameter("@codigoCliente", _lng_CodigoCliente)
                };
                #endregion

                //Delete
                obj_KairosProEntities.Database.ExecuteSqlCommand(str_SQL_Delete, arr_Parametros_Delete);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(TMP_Emails_RecordatorioFichajes_Datos) + "/" + nameof(Borrar), true);
            }
            finally
            {
                
                obj_KairosProEntities.Database.Connection.Close();
                obj_KairosProEntities.Dispose();
            }
        }
    }
}
